]> git.saurik.com Git - apt.git/blob - test/integration/framework
merge debian/sid into debian/experimental
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 # we all like colorful messages
6 if [ "$MSGCOLOR" != 'NO' ]; then
7 if [ ! -t 1 ]; then # but check that we output to a terminal
8 export MSGCOLOR='NO'
9 fi
10 fi
11
12
13 if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR="\033[1;31m" # red
15 CWARNING="\033[1;33m" # yellow
16 CMSG="\033[1;32m" # green
17 CINFO="\033[1;96m" # light blue
18 CDEBUG="\033[1;94m" # blue
19 CNORMAL="\033[0;39m" # default system console color
20 CDONE="\033[1;32m" # green
21 CPASS="\033[1;32m" # green
22 CFAIL="\033[1;31m" # red
23 CCMD="\033[1;35m" # pink
24 fi
25
26 msgprintf() {
27 local START="$1"
28 local MIDDLE="$2"
29 local END="$3"
30 shift 3
31 if [ -n "$1" ]; then
32 printf "$START " "$1"
33 shift
34 while [ -n "$1" ]; do
35 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')"
36 shift
37 done
38 fi
39 printf "${END}"
40 }
41 msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
42 msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
43 msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
44 msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
45 msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
46 msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
47 msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
48 msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
49 msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
50 msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
51 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
52 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
53 msgskip() {
54 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
55 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
56 }
57 msgfail() {
58 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
59 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
60 if [ -n "$APT_DEBUG_TESTS" ]; then
61 $SHELL
62 fi
63 EXIT_CODE=$((EXIT_CODE+1));
64 }
65
66 # enable / disable Debugging
67 MSGLEVEL=${MSGLEVEL:-3}
68 if [ $MSGLEVEL -le 0 ]; then
69 msgdie() { true; }
70 fi
71 if [ $MSGLEVEL -le 1 ]; then
72 msgwarn() { true; }
73 msgnwarn() { true; }
74 fi
75 if [ $MSGLEVEL -le 2 ]; then
76 msgmsg() { true; }
77 msgnmsg() { true; }
78 msgtest() { true; }
79 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
80 fi
81 if [ $MSGLEVEL -le 3 ]; then
82 msginfo() { true; }
83 msgninfo() { true; }
84 fi
85 if [ $MSGLEVEL -le 4 ]; then
86 msgdebug() { true; }
87 msgndebug() { true; }
88 fi
89 msgdone() {
90 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
91 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
92 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
93 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
94 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
95 true;
96 else
97 printf "${CDONE}DONE${CNORMAL}\n";
98 fi
99 }
100 getaptconfig() {
101 if [ -f ./aptconfig.conf ]; then
102 echo "./aptconfig.conf"
103 elif [ -f ../aptconfig.conf ]; then
104 echo "../aptconfig.conf"
105 fi
106 }
107 runapt() {
108 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
109 local CMD="$1"
110 shift
111 case $CMD in
112 sh|aptitude|*/*|command) ;;
113 *) CMD="${BUILDDIRECTORY}/$CMD";;
114 esac
115 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
116 }
117 aptconfig() { runapt apt-config "$@"; }
118 aptcache() { runapt apt-cache "$@"; }
119 aptcdrom() { runapt apt-cdrom "$@"; }
120 aptget() { runapt apt-get "$@"; }
121 aptftparchive() { runapt apt-ftparchive "$@"; }
122 aptkey() { runapt apt-key "$@"; }
123 aptmark() { runapt apt-mark "$@"; }
124 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
125 apt() { runapt apt "$@"; }
126 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
127 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
128 aptitude() { runapt aptitude "$@"; }
129 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
130 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
131 aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
132
133 dpkg() {
134 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
135 }
136 dpkgcheckbuilddeps() {
137 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
138 }
139 gdb() {
140 local CMD="$1"
141 shift
142 runapt command gdb --quiet -ex run "${BUILDDIRECTORY}/$CMD" --args "${BUILDDIRECTORY}/$CMD" "$@"
143 }
144
145 exitwithstatus() {
146 # error if we about to overflow, but ...
147 # "255 failures ought to be enough for everybody"
148 if [ $EXIT_CODE -gt 255 ]; then
149 msgdie "Total failure count $EXIT_CODE too big"
150 fi
151 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
152 }
153
154 shellsetedetector() {
155 local exit_status=$?
156 if [ "$exit_status" != '0' ]; then
157 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
158 if [ "$EXIT_CODE" = '0' ]; then
159 EXIT_CODE="$exit_status"
160 fi
161 fi
162 }
163
164 addtrap() {
165 if [ "$1" = 'prefix' ]; then
166 CURRENTTRAP="$2 $CURRENTTRAP"
167 else
168 CURRENTTRAP="$CURRENTTRAP $1"
169 fi
170 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
171 }
172
173 setupenvironment() {
174 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
175 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
176 unset TMPDIR
177 fi
178 TMPWORKINGDIRECTORY=$(mktemp -d)
179 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
180 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
181
182 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
183 if [ "$(id -u)" = '0' ]; then
184 # relax permissions so that running as root with user switching works
185 umask 022
186 chmod 711 "$TMPWORKINGDIRECTORY"
187 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
188 fi
189
190 TESTDIRECTORY=$(readlink -f $(dirname $0))
191 # allow overriding the default BUILDDIR location
192 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
193 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
194 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
195 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
196 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
197 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
198 APTDUMPSOLVER=${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}
199 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
200 # -----
201
202 cd $TMPWORKINGDIRECTORY
203 mkdir rootdir aptarchive keys
204 cd rootdir
205 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
206 mkdir -p usr/bin var/cache var/lib var/log tmp
207 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
208 touch var/lib/dpkg/available
209 mkdir -p usr/lib/apt
210 ln -s ${METHODSDIR} usr/lib/apt/methods
211 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
212 mkdir -p usr/lib/apt/solvers
213 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
214 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
215 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
216 fi
217 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
218 # system
219 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
220 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
221 else
222 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
223 fi
224 cd ..
225 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
226 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
227 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
228 fi
229 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
230 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
231 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
232 fi
233 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
234 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
235 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
236
237 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
238 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
239 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
240 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
241 # store apt-key were we can access it, even if we run it as a different user
242 # destroys coverage reporting though, so just do it for root for now
243 if [ "$(id -u)" = '0' ]; then
244 cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
245 chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
246 echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
247 else
248 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
249 fi
250
251 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
252 #!/bin/sh
253 set -e
254 if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
255 if [ -n "\$LD_PRELOAD" ]; then
256 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
257 else
258 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
259 fi
260 fi
261 exec fakeroot dpkg --root="${TMPWORKINGDIRECTORY}/rootdir" \\
262 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
263 --force-not-root --force-bad-path "\$@"
264 EOF
265 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
266 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
267
268 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
269 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
270 fi
271 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
272 echo 'quiet::NoStatistic "true";' >> aptconfig.conf
273 # too distracting for users, but helpful to detect changes
274 echo 'Acquire::Progress::Ignore::ShowErrorText "true";' >> aptconfig.conf
275 # in testcases, it can appear as if localhost has a rotation setup,
276 # hide this as we can't really deal with it properly
277 echo 'Acquire::Failure::ShowIP "false";' >> aptconfig.conf
278
279 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
280 if [ "$(id -u)" = '0' ]; then
281 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
282 fi
283 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
284 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
285 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
286
287 # create some files in /tmp and look at user/group to get what this means
288 TEST_DEFAULT_USER="$USER"
289 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
290 TEST_DEFAULT_GROUP='root'
291 else
292 TEST_DEFAULT_GROUP="$USER"
293 fi
294
295 # Acquire::AllowInsecureRepositories=false is not yet the default
296 # but we want it to be the default soon
297 configallowinsecurerepositories "false";
298
299 # cleanup the environment a bit
300 # prefer our apt binaries over the system apt binaries
301 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
302 export LC_ALL=C.UTF-8
303 unset LANGUAGE APT_CONFIG
304 unset GREP_OPTIONS DEB_BUILD_PROFILES
305
306 msgdone "info"
307 }
308
309 getarchitecture() {
310 if [ "$1" = "native" -o -z "$1" ]; then
311 eval `aptconfig shell ARCH APT::Architecture`
312 if [ -n "$ARCH" ]; then
313 echo $ARCH
314 else
315 dpkg --print-architecture
316 fi
317 else
318 echo $1
319 fi
320 }
321
322 getarchitectures() {
323 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
324 }
325
326 getarchitecturesfromcommalist() {
327 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
328 }
329
330 configarchitecture() {
331 {
332 echo "APT::Architecture \"$(getarchitecture $1)\";"
333 while [ -n "$1" ]; do
334 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
335 shift
336 done
337 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
338 configdpkg
339 }
340
341 configdpkg() {
342 if [ ! -e rootdir/var/lib/dpkg/status ]; then
343 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
344 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
345 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
346 else
347 echo -n > rootdir/var/lib/dpkg/status
348 fi
349 fi
350 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
351 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
352 local ARCHS="$(getarchitectures)"
353 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
354 DPKGARCH="$(dpkg --print-architecture)"
355 for ARCH in ${ARCHS}; do
356 if [ "${ARCH}" != "${DPKGARCH}" ]; then
357 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
358 # old-style used e.g. in Ubuntu-P – and as it seems travis
359 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
360 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
361 fi
362 fi
363 done
364 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
365 # dpkg doesn't really check the version as long as it is fully installed,
366 # but just to be sure we choose one above the required version
367 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
368 fi
369 fi
370 fi
371 }
372
373 configdpkgnoopchroot() {
374 # create a library to noop chroot() and rewrite maintainer script executions
375 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
376 # chroot directory dpkg could chroot into to execute the maintainer scripts
377 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
378 cat << EOF > noopchroot.c
379 #define _GNU_SOURCE
380 #include <stdio.h>
381 #include <stdlib.h>
382 #include <string.h>
383 #include <dlfcn.h>
384
385 static char * chrootdir = NULL;
386
387 int chroot(const char *path) {
388 printf("WARNING: CHROOTing to %s was ignored!\n", path);
389 free(chrootdir);
390 chrootdir = strdup(path);
391 return 0;
392 }
393 int execvp(const char *file, char *const argv[]) {
394 static int (*func_execvp) (const char *, char * const []) = NULL;
395 if (func_execvp == NULL)
396 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
397 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
398 return func_execvp(file, argv);
399 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
400 char newfile[strlen(chrootdir) + strlen(file)];
401 strcpy(newfile, chrootdir);
402 strcat(newfile, file);
403 char const * const baseadmindir = "/var/lib/dpkg";
404 char admindir[strlen(chrootdir) + strlen(baseadmindir)];
405 strcpy(admindir, chrootdir);
406 strcat(admindir, baseadmindir);
407 setenv("DPKG_ADMINDIR", admindir, 1);
408 return func_execvp(newfile, argv);
409 }
410 EOF
411 testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl
412 }
413
414 configallowinsecurerepositories() {
415 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
416
417 }
418
419 configcompression() {
420 while [ -n "$1" ]; do
421 case "$1" in
422 '.') printf ".\t.\tcat\n";;
423 'gz') printf "gzip\tgz\tgzip\n";;
424 'bz2') printf "bzip2\tbz2\tbzip2\n";;
425 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
426 'xz') printf "xz\txz\txz\n";;
427 *) printf "$1\t$1\t$1\n";;
428 esac
429 shift
430 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
431 }
432
433 forcecompressor() {
434 COMPRESSOR="$1"
435 COMPRESSOR_CMD="$1"
436 case $COMPRESSOR in
437 gzip) COMPRESS='gz';;
438 bzip2) COMPRESS='bz2';;
439 lzma) COMPRESS='lzma';;
440 xz) COMPRESS='xz';;
441 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
442 esac
443 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
444 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
445 Dir::Bin::uncompressed \"/does/not/exist\";
446 Dir::Bin::gzip \"/does/not/exist\";
447 Dir::Bin::bzip2 \"/does/not/exist\";
448 Dir::Bin::lzma \"/does/not/exist\";
449 Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
450 if [ -e "/bin/${COMPRESSOR}" ]; then
451 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
452 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
453 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
454 elif [ "${COMPRESSOR}" = 'lzma' ]; then
455 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
456 COMPRESSOR_CMD='xz --format=lzma'
457 else
458 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
459 msgfail
460 fi
461 }
462
463 setupsimplenativepackage() {
464 local NAME="$1"
465 local ARCH="$2"
466 local VERSION="$3"
467 local RELEASE="${4:-unstable}"
468 local DEPENDENCIES="$5"
469 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
470 If you find such a package installed on your system,
471 something went horribly wrong! They are autogenerated
472 und used only by testcases and surf no other propose…"}"
473
474 local SECTION="${7:-others}"
475 local DISTSECTION
476 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
477 DISTSECTION="main"
478 else
479 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
480 fi
481 local BUILDDIR=incoming/${NAME}-${VERSION}
482 mkdir -p ${BUILDDIR}/debian/source
483 cd ${BUILDDIR}
484 echo "* most suckless software product ever" > FEATURES
485 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
486 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
487
488 * Initial release
489
490 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
491 test -e debian/control || echo "Source: $NAME
492 Section: $SECTION
493 Priority: optional
494 Maintainer: Joe Sixpack <joe@example.org>
495 Build-Depends: debhelper (>= 7)
496 Standards-Version: 3.9.1
497
498 Package: $NAME" > debian/control
499 if [ "$ARCH" = 'all' ]; then
500 echo "Architecture: all" >> debian/control
501 else
502 echo "Architecture: any" >> debian/control
503 fi
504 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
505 echo "Description: $DESCRIPTION" >> debian/control
506
507 test -e debian/compat || echo "7" > debian/compat
508 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
509 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
510 cd - > /dev/null
511 }
512
513 buildsimplenativepackage() {
514 local NAME="$1"
515 local ARCH="$2"
516 local VERSION="$3"
517 local RELEASE="${4:-unstable}"
518 local DEPENDENCIES="$5"
519 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
520 If you find such a package installed on your system,
521 something went horribly wrong! They are autogenerated
522 und used only by testcases and surf no other propose…"}"
523
524 local SECTION="${7:-others}"
525 local PRIORITY="${8:-optional}"
526 local FILE_TREE="$9"
527 local COMPRESS_TYPE="${10:-gzip}"
528 local DISTSECTION
529 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
530 DISTSECTION="main"
531 else
532 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
533 fi
534 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
535
536 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
537 mkdir -p $BUILDDIR/debian/source
538 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
539 echo "#!/bin/sh
540 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
541
542 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
543 echo "$NAME ($VERSION) $RELEASE; urgency=low
544
545 * Initial release
546
547 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
548 echo "Source: $NAME
549 Section: $SECTION
550 Priority: $PRIORITY
551 Maintainer: Joe Sixpack <joe@example.org>
552 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
553 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
554 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
555 echo "
556 Package: $NAME" >> ${BUILDDIR}/debian/control
557
558 if [ "$ARCH" = 'all' ]; then
559 echo "Architecture: all" >> ${BUILDDIR}/debian/control
560 else
561 echo "Architecture: any" >> ${BUILDDIR}/debian/control
562 fi
563 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
564 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
565 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
566
567 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
568 cd ${BUILDDIR}/..
569 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
570 cd - >/dev/null
571 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output \
572 | while read SRC; do
573 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
574 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
575 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
576 # adv --yes --default-key 'Joe Sixpack' \
577 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
578 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
579 # fi
580 done
581
582 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
583 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
584 rm -rf ${BUILDDIR}/debian/tmp
585 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
586 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
587 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
588 if [ -n "$FILE_TREE" ]; then
589 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
590 fi
591
592 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
593 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
594 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
595 # ensure the right permissions as dpkg-deb ensists
596 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
597 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/..
598 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
599 done
600
601 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
602 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
603 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
604 rm -rf "${BUILDDIR}"
605 msgdone "info"
606 }
607
608 buildpackage() {
609 local BUILDDIR=$1
610 local RELEASE=$2
611 local SECTION=$3
612 local ARCH=$(getarchitecture $4)
613 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
614 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
615 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
616 cd $BUILDDIR
617 if [ "$ARCH" = "all" ]; then
618 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
619 fi
620 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
621 cp ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output $BUILDLOG
622 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
623 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
624 cd - > /dev/null
625 for PKG in $PKGS; do
626 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
627 done
628 for SRC in $SRCS; do
629 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
630 done
631 }
632
633 buildaptarchive() {
634 if [ -d incoming ]; then
635 buildaptarchivefromincoming "$@"
636 else
637 buildaptarchivefromfiles "$@"
638 fi
639 }
640
641 createaptftparchiveconfig() {
642 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
643 local COMPRESSORS="${COMPRESSORS%* }"
644 local ARCHS="$(getarchitectures)"
645 echo -n 'Dir {
646 ArchiveDir "' >> ftparchive.conf
647 echo -n $(readlink -f .) >> ftparchive.conf
648 echo -n '";
649 CacheDir "' >> ftparchive.conf
650 echo -n $(readlink -f ..) >> ftparchive.conf
651 echo -n '";
652 FileListDir "' >> ftparchive.conf
653 echo -n $(readlink -f pool/) >> ftparchive.conf
654 echo -n '";
655 };
656 Default {
657 Packages::Compress "'"$COMPRESSORS"'";
658 Sources::Compress "'"$COMPRESSORS"'";
659 Contents::Compress "'"$COMPRESSORS"'";
660 Translation::Compress "'"$COMPRESSORS"'";
661 LongDescription "false";
662 };
663 TreeDefault {
664 Directory "pool/";
665 SrcDirectory "pool/";
666 };
667 APT {
668 FTPArchive {
669 Release {
670 Origin "joesixpack";
671 Label "apttestcases";
672 Suite "unstable";
673 Description "repository with dummy packages";
674 Architectures "' >> ftparchive.conf
675 echo -n "$ARCHS" >> ftparchive.conf
676 echo 'source";
677 };
678 };
679 };' >> ftparchive.conf
680 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
681 echo -n 'tree "dists/' >> ftparchive.conf
682 echo -n "$DIST" >> ftparchive.conf
683 echo -n '" {
684 Architectures "' >> ftparchive.conf
685 echo -n "$ARCHS" >> ftparchive.conf
686 echo -n 'source";
687 FileList "' >> ftparchive.conf
688 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
689 echo -n '";
690 SourceFileList "' >> ftparchive.conf
691 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
692 echo -n '";
693 Sections "' >> ftparchive.conf
694 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
695 echo '";
696 };' >> ftparchive.conf
697 done
698 }
699
700 buildaptftparchivedirectorystructure() {
701 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
702 for DIST in $DISTS; do
703 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
704 for SECTION in $SECTIONS; do
705 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
706 for ARCH in $ARCHS; do
707 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
708 done
709 mkdir -p dists/${DIST}/${SECTION}/source
710 mkdir -p dists/${DIST}/${SECTION}/i18n
711 done
712 done
713 }
714
715 insertpackage() {
716 local RELEASES="$1"
717 local NAME="$2"
718 local ARCH="$3"
719 local VERSION="$4"
720 local DEPENDENCIES="$5"
721 local PRIORITY="${6:-optional}"
722 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
723 If you find such a package installed on your system,
724 something went horribly wrong! They are autogenerated
725 und used only by testcases and surf no other propose…"}"
726 local ARCHS=""
727 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
728 if [ "$RELEASE" = 'installed' ]; then
729 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
730 continue
731 fi
732 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
733 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
734 ARCHS="$(getarchitectures)"
735 else
736 ARCHS="$arch"
737 fi
738 for BUILDARCH in $ARCHS; do
739 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
740 mkdir -p $PPATH
741 local FILE="${PPATH}/Packages"
742 echo "Package: $NAME
743 Priority: $PRIORITY
744 Section: other
745 Installed-Size: 42
746 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
747 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
748 echo "Version: $VERSION
749 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
750 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
751 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" >> $FILE
752 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" >> $FILE
753 echo >> $FILE
754 done
755 done
756 mkdir -p aptarchive/dists/${RELEASE}/main/source aptarchive/dists/${RELEASE}/main/i18n
757 touch aptarchive/dists/${RELEASE}/main/source/Sources
758 echo "Package: $NAME
759 Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
760 Description-en: $DESCRIPTION
761 " >> aptarchive/dists/${RELEASE}/main/i18n/Translation-en
762 done
763 }
764
765 insertsource() {
766 local RELEASE="$1"
767 local NAME="$2"
768 local ARCH="$3"
769 local VERSION="$4"
770 local DEPENDENCIES="$5"
771 local ARCHS=""
772 local SPATH="aptarchive/dists/${RELEASE}/main/source"
773 mkdir -p $SPATH
774 local FILE="${SPATH}/Sources"
775 echo "Package: $NAME
776 Binary: $NAME
777 Version: $VERSION
778 Maintainer: Joe Sixpack <joe@example.org>
779 Architecture: $ARCH" >> $FILE
780 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
781 echo "Files:
782 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
783 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
784 " >> $FILE
785 }
786
787 insertinstalledpackage() {
788 local NAME="$1"
789 local ARCH="$2"
790 local VERSION="$3"
791 local DEPENDENCIES="$4"
792 local PRIORITY="${5:-optional}"
793 local STATUS="${6:-install ok installed}"
794 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
795 If you find such a package installed on your system,
796 something went horribly wrong! They are autogenerated
797 und used only by testcases and surf no other propose…"}"
798
799 local FILE='rootdir/var/lib/dpkg/status'
800 local INFO='rootdir/var/lib/dpkg/info'
801 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
802 echo "Package: $NAME
803 Status: $STATUS
804 Priority: $PRIORITY
805 Section: other
806 Installed-Size: 42
807 Maintainer: Joe Sixpack <joe@example.org>
808 Version: $VERSION" >> $FILE
809 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
810 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
811 echo "Description: $DESCRIPTION" >> $FILE
812 echo >> $FILE
813 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
814 echo -n > ${INFO}/${NAME}:${arch}.list
815 else
816 echo -n > ${INFO}/${NAME}.list
817 fi
818 done
819 }
820
821
822 buildaptarchivefromincoming() {
823 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
824 cd aptarchive
825 [ -e pool ] || ln -s ../incoming pool
826 [ -e ftparchive.conf ] || createaptftparchiveconfig
827 [ -e dists ] || buildaptftparchivedirectorystructure
828 msgninfo "\tGenerate Packages, Sources and Contents files… "
829 testsuccess aptftparchive generate ftparchive.conf
830 cd - > /dev/null
831 msgdone "info"
832 generatereleasefiles "$@"
833 }
834
835 buildaptarchivefromfiles() {
836 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
837 find aptarchive -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
838 msgninfo "\t${line} file… "
839 compressfile "$line" "$1"
840 msgdone "info"
841 done
842 generatereleasefiles "$@"
843 }
844
845 compressfile() {
846 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
847 if [ "$compressor" = '.' ]; then
848 if [ -n "$2" ]; then
849 touch -d "$2" "$1"
850 fi
851 continue
852 fi
853 cat "$1" | $command > "${1}.${extension}"
854 if [ -n "$2" ]; then
855 touch -d "$2" "${1}.${extension}"
856 fi
857 done
858 }
859
860 # can be overridden by testcases for their pleasure
861 getcodenamefromsuite() {
862 case "$1" in
863 unstable) echo 'sid';;
864 *) echo -n "$1";;
865 esac
866 }
867 getreleaseversionfromsuite() { true; }
868 getlabelfromsuite() { true; }
869
870 generatereleasefiles() {
871 # $1 is the Date header and $2 is the ValidUntil header to be set
872 # both should be given in notation date/touch can understand
873 msgninfo "\tGenerate Release files… "
874 if [ -e aptarchive/dists ]; then
875 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
876 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
877 local CODENAME="$(getcodenamefromsuite $SUITE)"
878 local VERSION="$(getreleaseversionfromsuite $SUITE)"
879 local LABEL="$(getlabelfromsuite $SUITE)"
880 if [ -n "$VERSION" ]; then
881 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
882 fi
883 if [ -n "$LABEL" ]; then
884 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
885 fi
886 aptftparchive -qq release $dir \
887 -o APT::FTPArchive::Release::Suite="${SUITE}" \
888 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
889 ${LABEL} \
890 ${VERSION} \
891 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
892 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
893 sed -i '/^Date: / a\
894 NotAutomatic: yes' $dir/Release
895 fi
896 if [ -n "$1" -a "$1" != "now" ]; then
897 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
898 fi
899 if [ -n "$2" ]; then
900 sed -i "/^Date: / a\
901 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
902 fi
903 done
904 else
905 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
906 fi
907 if [ -n "$1" -a "$1" != "now" ]; then
908 for release in $(find ./aptarchive -name 'Release'); do
909 touch -d "$1" $release
910 done
911 fi
912 msgdone "info"
913 }
914
915 setupdistsaptarchive() {
916 local APTARCHIVE=$(readlink -f ./aptarchive)
917 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
918 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
919 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
920 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
921 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
922 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
923 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
924 msgdone "info"
925 done
926 }
927
928 setupflataptarchive() {
929 local APTARCHIVE=$(readlink -f ./aptarchive)
930 if [ -f ${APTARCHIVE}/Packages ]; then
931 msgninfo "\tadd deb sources.list line… "
932 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
933 msgdone "info"
934 else
935 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
936 fi
937 if [ -f ${APTARCHIVE}/Sources ]; then
938 msgninfo "\tadd deb-src sources.list line… "
939 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
940 msgdone "info"
941 else
942 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
943 fi
944 }
945
946 setupaptarchive() {
947 local NOUPDATE=0
948 if [ "$1" = '--no-update' ]; then
949 NOUPDATE=1
950 shift
951 fi
952 buildaptarchive "$@"
953 if [ -e aptarchive/dists ]; then
954 setupdistsaptarchive
955 else
956 setupflataptarchive
957 fi
958 signreleasefiles 'Joe Sixpack'
959 if [ "1" != "$NOUPDATE" ]; then
960 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
961 fi
962 }
963
964 signreleasefiles() {
965 local SIGNER="${1:-Joe Sixpack}"
966 local REPODIR="${2:-aptarchive}"
967 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
968 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
969 msgninfo "\tSign archive with $SIGNER key $KEY… "
970 local REXKEY='keys/rexexpired'
971 local SECEXPIREBAK="${REXKEY}.sec.bak"
972 local PUBEXPIREBAK="${REXKEY}.pub.bak"
973 if [ "${SIGNER}" = 'Rex Expired' ]; then
974 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
975 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
976 # therefore we 'temporary' make the key not expired and restore a backup after signing
977 cp ${REXKEY}.sec $SECEXPIREBAK
978 cp ${REXKEY}.pub $PUBEXPIREBAK
979 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
980 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
981 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
982 cp $SECUNEXPIRED ${REXKEY}.sec
983 cp $PUBUNEXPIRED ${REXKEY}.pub
984 else
985 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
986 cat setexpire.gpg
987 exit 1
988 fi
989 cp ${REXKEY}.sec $SECUNEXPIRED
990 cp ${REXKEY}.pub $PUBUNEXPIRED
991 fi
992 fi
993 for RELEASE in $(find ${REPODIR}/ -name Release); do
994 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
995 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
996 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
997 # we might have set a specific date for the Release file, so copy it
998 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
999 done
1000 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1001 mv -f $SECEXPIREBAK ${REXKEY}.sec
1002 mv -f $PUBEXPIREBAK ${REXKEY}.pub
1003 fi
1004 msgdone "info"
1005 }
1006
1007 webserverconfig() {
1008 local NOCHECK=false
1009 if [ "$1" = '--no-check' ]; then
1010 NOCHECK=true
1011 shift
1012 fi
1013 local DOWNLOG='rootdir/tmp/download-testfile.log'
1014 local STATUS='downloaded/webserverconfig.status'
1015 rm -f "$STATUS" "$DOWNLOG"
1016 local URI
1017 if [ -n "$2" ]; then
1018 msgtest "Set webserver config option '${1}' to" "$2"
1019 URI="http://localhost:8080/_config/set/${1}/${2}"
1020 else
1021 msgtest 'Clear webserver config option' "${1}"
1022 URI="http://localhost:8080/_config/clear/${1}"
1023 fi
1024 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
1025 msgpass
1026 else
1027 cat "$DOWNLOG" "$STATUS" || true
1028 msgfail
1029 fi
1030 $NOCHECK || testwebserverlaststatuscode '200'
1031 }
1032
1033 rewritesourceslist() {
1034 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
1035 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
1036 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#https://localhost:4433/#${1}#"
1037 done
1038 }
1039
1040 # wait for up to 10s for a pid file to appear to avoid possible race
1041 # when a helper is started and dosn't write the PID quick enough
1042 waitforpidfile() {
1043 local PIDFILE="$1"
1044 for i in $(seq 10); do
1045 if test -s "$PIDFILE"; then
1046 return 0
1047 fi
1048 sleep 1
1049 done
1050 msgdie "waiting for $PIDFILE failed"
1051 return 1
1052 }
1053
1054 changetowebserver() {
1055 if [ "$1" != '--no-rewrite' ]; then
1056 rewritesourceslist 'http://localhost:8080/'
1057 else
1058 shift
1059 fi
1060 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
1061 cd aptarchive
1062 local LOG="webserver.log"
1063 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
1064 cat $LOG
1065 false
1066 fi
1067 waitforpidfile aptwebserver.pid
1068 local PID="$(cat aptwebserver.pid)"
1069 if [ -z "$PID" ]; then
1070 msgdie 'Could not fork aptwebserver successfully'
1071 fi
1072 addtrap "kill $PID;"
1073 cd - > /dev/null
1074 else
1075 msgdie 'You have to build aptwerbserver or install a webserver'
1076 fi
1077 }
1078
1079 changetohttpswebserver() {
1080 if ! which stunnel4 >/dev/null; then
1081 msgdie 'You need to install stunnel4 for https testcases'
1082 fi
1083 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1084 changetowebserver --no-rewrite "$@"
1085 fi
1086 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1087 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1088 output = /dev/null
1089
1090 [https]
1091 accept = 4433
1092 connect = 8080
1093 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
1094 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
1095 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1096 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
1097 if [ -z "$PID" ]; then
1098 msgdie 'Could not fork stunnel4 successfully'
1099 fi
1100 addtrap 'prefix' "kill ${PID};"
1101 rewritesourceslist 'https://localhost:4433/'
1102 }
1103
1104 changetocdrom() {
1105 mkdir -p rootdir/media/cdrom/.disk
1106 local CD="$(readlink -f rootdir/media/cdrom)"
1107 echo "acquire::cdrom::mount \"${CD}\";
1108 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1109 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1110 acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
1111 echo -n "$1" > ${CD}/.disk/info
1112 if [ ! -d aptarchive/dists ]; then
1113 msgdie 'Flat file archive cdroms can not be created currently'
1114 return 1
1115 fi
1116 mv aptarchive/dists "$CD"
1117 ln -s "$(readlink -f ./incoming)" $CD/pool
1118 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1119 # start with an unmounted disk
1120 mv "${CD}" "${CD}-unmounted"
1121 # we don't want the disk to be modifiable
1122 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1123 chmod -R 555 rootdir/media/cdrom-unmounted/dists
1124 }
1125
1126 downloadfile() {
1127 local PROTO="${1%%:*}"
1128 apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
1129 download-file "$1" "$2" 2>&1 || true
1130 # only if the file exists the download was successful
1131 if [ -r "$2" ]; then
1132 return 0
1133 else
1134 return 1
1135 fi
1136 }
1137
1138 checkdiff() {
1139 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1140 if [ -n "$DIFFTEXT" ]; then
1141 echo >&2
1142 echo >&2 "$DIFFTEXT"
1143 return 1
1144 else
1145 return 0
1146 fi
1147 }
1148
1149 testfileequal() {
1150 local FILE="$1"
1151 shift
1152 msgtest "Test for correctness of file" "$FILE"
1153 if [ -z "$*" ]; then
1154 echo -n "" | checkdiff $FILE - && msgpass || msgfail
1155 else
1156 echo "$*" | checkdiff $FILE - && msgpass || msgfail
1157 fi
1158 }
1159
1160 testempty() {
1161 msgtest "Test for no output of" "$*"
1162 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1163 if "$@" >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1164 msgpass
1165 else
1166 echo
1167 cat $COMPAREFILE
1168 msgfail
1169 fi
1170 aptautotest 'testempty' "$@"
1171 }
1172
1173 testequal() {
1174 local MSG='Test of equality of'
1175 if [ "$1" = '--nomsg' ]; then
1176 MSG=''
1177 shift
1178 fi
1179
1180 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1181 echo "$1" > $COMPAREFILE
1182 shift
1183
1184 if [ -n "$MSG" ]; then
1185 msgtest "$MSG" "$*"
1186 fi
1187 "$@" 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1188 aptautotest 'testequal' "$@"
1189 }
1190
1191 testequalor2() {
1192 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1193 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1194 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1195 echo "$1" > $COMPAREFILE1
1196 echo "$2" > $COMPAREFILE2
1197 shift 2
1198 msgtest "Test for equality OR of" "$*"
1199 "$@" >$COMPAREAGAINST 2>&1 || true
1200 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1201 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1202 then
1203 msgpass
1204 else
1205 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1206 checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
1207 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1208 checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
1209 msgfail
1210 fi
1211 aptautotest 'testequalor2' "$@"
1212 }
1213
1214 testshowvirtual() {
1215 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1216 local PACKAGE="$1"
1217 shift
1218 while [ -n "$1" ]; do
1219 VIRTUAL="${VIRTUAL}
1220 N: Can't select versions from package '$1' as it is purely virtual"
1221 PACKAGE="${PACKAGE} $1"
1222 shift
1223 done
1224 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1225 VIRTUAL="${VIRTUAL}
1226 N: No packages found"
1227 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1228 local ARCH="$(getarchitecture 'native')"
1229 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
1230 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1231 }
1232
1233 testnopackage() {
1234 msgtest "Test for non-existent packages" "apt-cache show $*"
1235 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1236 if [ -n "$SHOWPKG" ]; then
1237 echo >&2
1238 echo >&2 "$SHOWPKG"
1239 msgfail
1240 else
1241 msgpass
1242 fi
1243 }
1244
1245 testdpkgstatus() {
1246 local STATE="$1"
1247 local NR="$2"
1248 shift 2
1249 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1250 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1251 if [ "$PKGS" != $NR ]; then
1252 echo >&2 $PKGS
1253 dpkg -l "$@" | grep '^[a-z]' >&2
1254 msgfail
1255 else
1256 msgpass
1257 fi
1258 }
1259
1260 testdpkginstalled() {
1261 testdpkgstatus 'ii' "$#" "$@"
1262 }
1263
1264 testdpkgnotinstalled() {
1265 testdpkgstatus 'ii' '0' "$@"
1266 }
1267
1268 testmarkedauto() {
1269 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1270 if [ -n "$1" ]; then
1271 msgtest 'Test for correctly marked as auto-installed' "$*"
1272 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1273 else
1274 msgtest 'Test for correctly marked as auto-installed' 'no package'
1275 echo -n > $COMPAREFILE
1276 fi
1277 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1278 }
1279
1280 msgfailoutput() {
1281 local MSG="$1"
1282 local OUTPUT="$2"
1283 shift 2
1284 echo >&2
1285 if [ "$1" = 'grep' ]; then
1286 while [ -n "$2" ]; do shift; done
1287 echo "#### Complete file: $1 ####"
1288 cat >&2 "$1" || true
1289 echo '#### grep output ####'
1290 elif [ "$1" = 'test' ]; then
1291 # doesn't support ! or non-file flags
1292 msgfailoutputstatfile() {
1293 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1294 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1295 echo "#### stat(2) of file: $2 ####"
1296 stat "$2" || true
1297 fi
1298 }
1299 msgfailoutputstatfile "$2" "$3"
1300 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1301 shift 3
1302 msgfailoutputstatfile "$2" "$3"
1303 done
1304 echo '#### test output ####'
1305 fi
1306 cat >&2 $OUTPUT
1307 msgfail "$MSG"
1308 }
1309
1310 testsuccess() {
1311 if [ "$1" = '--nomsg' ]; then
1312 shift
1313 else
1314 msgtest 'Test for successful execution of' "$*"
1315 fi
1316 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1317 if "$@" >${OUTPUT} 2>&1; then
1318 if expr match "$1" '^apt.*' >/dev/null; then
1319 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1320 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1321 elif grep -q -E '^[WE]: ' "$OUTPUT"; then
1322 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1323 else
1324 msgpass
1325 fi
1326 else
1327 msgpass
1328 fi
1329 else
1330 local EXITCODE=$?
1331 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1332 fi
1333 aptautotest 'testsuccess' "$@"
1334 }
1335 testwarning() {
1336 if [ "$1" = '--nomsg' ]; then
1337 shift
1338 else
1339 msgtest 'Test for successful execution with warnings of' "$*"
1340 fi
1341 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1342 if "$@" >${OUTPUT} 2>&1; then
1343 if expr match "$1" '^apt.*' >/dev/null; then
1344 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1345 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1346 elif grep -q -E '^E: ' "$OUTPUT"; then
1347 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
1348 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1349 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1350 else
1351 msgpass
1352 fi
1353 else
1354 msgpass
1355 fi
1356 else
1357 local EXITCODE=$?
1358 echo >&2
1359 cat >&2 $OUTPUT
1360 msgfail "exitcode $EXITCODE"
1361 fi
1362 aptautotest 'testwarning' "$@"
1363 }
1364 testfailure() {
1365 if [ "$1" = '--nomsg' ]; then
1366 shift
1367 else
1368 msgtest 'Test for failure in execution of' "$*"
1369 fi
1370 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1371 if "$@" >${OUTPUT} 2>&1; then
1372 local EXITCODE=$?
1373 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1374 else
1375 local EXITCODE=$?
1376 if expr match "$1" '^apt.*' >/dev/null; then
1377 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1378 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1379 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1380 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1381 else
1382 msgpass
1383 fi
1384 else
1385 msgpass
1386 fi
1387 fi
1388 aptautotest 'testfailure' "$@"
1389 }
1390
1391 testfilestats() {
1392 msgtest "Test that file $1 has $2 $3" "$4"
1393 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1394 msgpass
1395 else
1396 echo >&2
1397 ls -ld >&2 "$1"
1398 echo -n >&2 "stat(1) reports for $2: "
1399 stat --format "$2" "$1"
1400 msgfail
1401 fi
1402 }
1403 testaccessrights() {
1404 testfilestats "$1" '%a' '=' "$2"
1405 }
1406
1407 testwebserverlaststatuscode() {
1408 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1409 local STATUS='downloaded/webserverstatus-statusfile.log'
1410 rm -f "$DOWNLOG" "$STATUS"
1411 msgtest 'Test last status code from the webserver was' "$1"
1412 if downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1413 msgpass
1414 else
1415 echo >&2
1416 if [ -n "$2" ]; then
1417 shift
1418 echo >&2 '#### Additionally provided output files contain:'
1419 cat >&2 "$@"
1420 fi
1421 echo >&2 '#### Download log of the status code:'
1422 cat >&2 "$DOWNLOG"
1423 msgfail "Status was $(cat "$STATUS")"
1424 fi
1425 }
1426
1427 pause() {
1428 echo "STOPPED execution. Press enter to continue"
1429 local IGNORE
1430 read IGNORE
1431 }
1432
1433 listcurrentlistsdirectory() {
1434 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1435 stat --format '%U:%G:%a:%n' "$line"
1436 done
1437 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1438 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1439 done
1440 }
1441
1442 ### convinience hacks ###
1443 mkdir() {
1444 # creating some directories by hand is a tedious task, so make it look simple
1445 if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] ||
1446 [ "$*" = '-p rootdir/var/lib/apt/lists/partial' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" ]; then
1447 # only the last directory created by mkdir is effected by the -m !
1448 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1449 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1450 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1451 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1452 if [ "$(id -u)" = '0' ]; then
1453 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1454 fi
1455 else
1456 command mkdir "$@"
1457 fi
1458 }
1459
1460 ### The following tests are run by most test methods automatically to check
1461 ### general things about commands executed without writing the test every time.
1462
1463 aptautotest() {
1464 local TESTCALL="$1"
1465 local CMD="$2"
1466 local FIRSTOPT="$3"
1467 local AUTOTEST="aptautotest_$(basename "$CMD" | tr -d '-')_$(echo "$FIRSTOPT" | tr -d '-')"
1468 if command -v $AUTOTEST >/dev/null; then
1469 shift 3
1470 # save and restore the *.output files from other tests
1471 # as we might otherwise override them in these automatic tests
1472 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1473 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1474 mkdir ${TMPWORKINGDIRECTORY}/rootdir/tmp
1475 $AUTOTEST "$TESTCALL" "$@"
1476 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1477 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1478 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp-before ${TMPWORKINGDIRECTORY}/rootdir/tmp
1479 fi
1480 }
1481
1482 aptautotest_aptget_update() {
1483 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1484 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1485 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1486 # all copied files are properly chmodded
1487 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -maxdepth 1 -type f ! -name 'lock'); do
1488 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
1489 done
1490 }
1491 aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
1492
1493 testaptautotestnodpkgwarning() {
1494 local TESTCALL="$1"
1495 while [ -n "$2" ]; do
1496 if [ "$2" = '-s' ]; then return; fi
1497 shift
1498 done
1499 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1500 }
1501
1502 aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1503 aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1504 aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1505 aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1506 aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1507 aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }